<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SysInfo.Component StructType
 * @subpackage Structs
 */
class SysInfo_Component extends AnyEntity
{
    /**
     * The ConfigEntityName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ConfigEntityName;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Description;
    /**
     * The Implements
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Implements;
    /**
     * The InheritedFrom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InheritedFrom;
    /**
     * The IsAbstract
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsAbstract;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Title;
    /**
     * Constructor method for SysInfo.Component
     * @uses SysInfo_Component::setConfigEntityName()
     * @uses SysInfo_Component::setDescription()
     * @uses SysInfo_Component::setImplements()
     * @uses SysInfo_Component::setInheritedFrom()
     * @uses SysInfo_Component::setIsAbstract()
     * @uses SysInfo_Component::setName()
     * @uses SysInfo_Component::setTitle()
     * @param string $configEntityName
     * @param string $description
     * @param string $implements
     * @param string $inheritedFrom
     * @param bool $isAbstract
     * @param string $name
     * @param string $title
     */
    public function __construct($configEntityName = null, $description = null, $implements = null, $inheritedFrom = null, $isAbstract = null, $name = null, $title = null)
    {
        $this
            ->setConfigEntityName($configEntityName)
            ->setDescription($description)
            ->setImplements($implements)
            ->setInheritedFrom($inheritedFrom)
            ->setIsAbstract($isAbstract)
            ->setName($name)
            ->setTitle($title);
    }
    /**
     * Get ConfigEntityName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConfigEntityName()
    {
        return isset($this->ConfigEntityName) ? $this->ConfigEntityName : null;
    }
    /**
     * Set ConfigEntityName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $configEntityName
     * @return \patest\StructType\SysInfo_Component
     */
    public function setConfigEntityName($configEntityName = null)
    {
        // validation for constraint: string
        if (!is_null($configEntityName) && !is_string($configEntityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($configEntityName, true), gettype($configEntityName)), __LINE__);
        }
        if (is_null($configEntityName) || (is_array($configEntityName) && empty($configEntityName))) {
            unset($this->ConfigEntityName);
        } else {
            $this->ConfigEntityName = $configEntityName;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \patest\StructType\SysInfo_Component
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Implements value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImplements()
    {
        return isset($this->Implements) ? $this->Implements : null;
    }
    /**
     * Set Implements value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $implements
     * @return \patest\StructType\SysInfo_Component
     */
    public function setImplements($implements = null)
    {
        // validation for constraint: string
        if (!is_null($implements) && !is_string($implements)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($implements, true), gettype($implements)), __LINE__);
        }
        if (is_null($implements) || (is_array($implements) && empty($implements))) {
            unset($this->Implements);
        } else {
            $this->Implements = $implements;
        }
        return $this;
    }
    /**
     * Get InheritedFrom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInheritedFrom()
    {
        return isset($this->InheritedFrom) ? $this->InheritedFrom : null;
    }
    /**
     * Set InheritedFrom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $inheritedFrom
     * @return \patest\StructType\SysInfo_Component
     */
    public function setInheritedFrom($inheritedFrom = null)
    {
        // validation for constraint: string
        if (!is_null($inheritedFrom) && !is_string($inheritedFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inheritedFrom, true), gettype($inheritedFrom)), __LINE__);
        }
        if (is_null($inheritedFrom) || (is_array($inheritedFrom) && empty($inheritedFrom))) {
            unset($this->InheritedFrom);
        } else {
            $this->InheritedFrom = $inheritedFrom;
        }
        return $this;
    }
    /**
     * Get IsAbstract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsAbstract()
    {
        return isset($this->IsAbstract) ? $this->IsAbstract : null;
    }
    /**
     * Set IsAbstract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isAbstract
     * @return \patest\StructType\SysInfo_Component
     */
    public function setIsAbstract($isAbstract = null)
    {
        // validation for constraint: boolean
        if (!is_null($isAbstract) && !is_bool($isAbstract)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isAbstract, true), gettype($isAbstract)), __LINE__);
        }
        if (is_null($isAbstract) || (is_array($isAbstract) && empty($isAbstract))) {
            unset($this->IsAbstract);
        } else {
            $this->IsAbstract = $isAbstract;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \patest\StructType\SysInfo_Component
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get Title value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitle()
    {
        return isset($this->Title) ? $this->Title : null;
    }
    /**
     * Set Title value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $title
     * @return \patest\StructType\SysInfo_Component
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        if (is_null($title) || (is_array($title) && empty($title))) {
            unset($this->Title);
        } else {
            $this->Title = $title;
        }
        return $this;
    }
}
